#include "stdafx.h"
#include "lsapi.h"
#include "FileInformation.h"
#include "NotifyDirCheck.h"

#define _MERGE_RDATA_
#include "AggressiveOptimize.h"

#include <list>

using namespace std;

class CNotifyDirCheck;

typedef list<CNotifyDirCheck *> DirCheckList;
typedef list<CNotifyDirCheck *>::iterator DirCheckListIterator;

DirCheckList dircheckList;

CStringList pathList;

/* The one and only exported functions */
extern "C"
{
__declspec( dllexport ) void OnStart(LPCSTR path);
__declspec( dllexport ) void OnStop(LPCSTR path = NULL);
}

UINT DirCallback( CFileInformation fiObject, EFileAction faAction, LPVOID lpData )
{
	CString Bang;
	CString filepath = fiObject.GetFilePath();

	bool found = false;
	POSITION m_position = pathList.GetHeadPosition();
	while (m_position != NULL && found == FALSE)
	{
		if ( fiObject.IsSomeFileDir( pathList.GetAt(m_position) ) )
			found = TRUE;
		pathList.GetNext(m_position);
	}

	if (found)
	{
		if( IS_CREATE_FILE( faAction ) )
		{
			Bang = ("!labeldesktopcreate updateadd \"" + filepath + "\"");
			LSExecute(NULL, Bang, SW_SHOWNORMAL);
		}
		else if( IS_DELETE_FILE( faAction ) )
		{
			Bang = ("!labeldesktopcreate updatedel \"" + filepath + "\"");
			LSExecute(NULL, Bang, SW_SHOWNORMAL);
		}
		else if( IS_CHANGE_FILE( faAction ) )
		{
			Bang = ("!labeldesktopcreate updateren \"" + filepath + "\"");
			LSExecute(NULL, Bang, SW_SHOWNORMAL);
		}
		else
		{
			return 1; //error, stop thread
		}
	}

	return 0; //success
}

void OnStart(LPCSTR path) 
{
	CNotifyDirCheck *DirCheck = new CNotifyDirCheck();
	
	dircheckList.insert(dircheckList.end(), DirCheck);
		
	DirCheck->SetDirectory( path );
	pathList.AddTail( path );

	//set your callback to work with each new event
	DirCheck->SetActionCallback( DirCallback );

	DirCheck->Run();
}

void OnStop(LPCSTR path) 
{
	if (path == NULL)
	{
		for(DirCheckListIterator dcit = dircheckList.begin(); dcit != dircheckList.end(); dcit++)
		{
			(*dcit)->Stop();
			delete *dcit;
		}

		pathList.RemoveAll();
		dircheckList.clear();
	}
	else
	{
		for(DirCheckListIterator dcit = dircheckList.begin(); dcit != dircheckList.end(); dcit++)
		{
			if((*dcit)->GetDirectory().CompareNoCase(path) == 0)
			{
				(*dcit)->Stop();
				dircheckList.remove( *dcit );
				pathList.RemoveAt(pathList.Find( path, NULL));
			}
		}
	}
}


